#include "F_Text_Color_Selector_Code.dm"

/*
    This is a text mode variation of my F_Color_Selection library.

    There is only one function:

    F_TCS.Get_Color(mob/M, default_color = null)


    You can actually send either a mob with a client, or a client directly as
    the first argument.  The second argument is optional, and would set the
    current_color of the selection box to whatever you send.

    You will also need to test if the proc returns a value, as players may simply
    cancel the selection without choosing anything.  In this case, null is returned.
    Otherwise, the html formatted color is returned.

    EX:

    mob
    	var
    		my_color = "#55aa33"

    	New()
    		..()
    		Colorize()

    	verb
    		Set_Color()
    			var/new_color = F_TCS.Get_Color(src, my_color)  // Input a new color
    			if(new_color)                                   // If a color was selected
    				my_color = new_color                          // Set the mobs color to it
    				Colorize()                                    // Recolor the mob
    	proc
    		Colorize()
    			text = "<font color=[my_color]>@"








*/
