#define FTCS_Background "#999999"
#define FTCS_Button "#bbbbbb"
#define FTCS_Cancel "#FFFFFF"
#define FTCS_Cancel_Background "#FF0000"
#define FTCS_Layer 1000
#define FTCS_Help_Background "#0000dd"
#define FTCS_Help_Color "#FFFFFF"

var/f_text_color_selector_handler/F_TCS
world
	New()
		..()
		F_TCS = new()

f_text_color_selector_handler
	var
		current_clients[0]
		current_selectors[0]

	proc
		Get_Color(mob/M, default_color = null)
			if(ismob(M))
				if(!M.client)
					world.log << "<b>ERROR:</b> Call to f_text_color_selector_handler passed mob with no client."
					return
			var/client/C
			if(ismob(M))
				C = M.client
			else if(istype(M, /client))
				C = M
			else
				world.log << "<b>ERROR:</b> Call to f_text_color_selector_handler passed invalid value.  (Not a client or mob with client.)"
			if(C in current_clients)
				return
			current_clients += C
			var/f_text_color_selector/F = new(C, default_color)
			current_selectors += F
			var/color = F.Get_Color(C)
			del F
			current_clients -= C
			return color

f_text_color_selector
	var
		pieces[0]
		R = 0
		G = 0
		B = 0
		current_color
		background[0]
		obj/FTCS_Object/current_color/Current_Color
		ok_buttons[0]
		waiting = TRUE


	New(client/C, default_color)
		..()
		if(default_color) current_color = default_color
		Setup(C)
	Del()
		for(var/V in (ok_buttons + pieces + background + Current_Color))
			del V
		..()
	proc
		Cancel()
			current_color = null
			waiting = FALSE

		Setup(client/C)
			var/i
			var/xval = Get_X(C)
			var/yval = Get_Y(C)
			Show_Text(xval,yval, C)
			Show_Buttons(xval,yval,C)
			Set_Background(xval,yval,C)
			Current_Color = new(null,"[xval+5],[yval-1]", C)
			Current_Color.Update_Color(current_color)
			for(i=0, i<=3, i++)
				pieces += new /obj/FTCS_Object/color_slider/red(null,i,"[xval+i],[yval-1]", src)
				pieces += new /obj/FTCS_Object/color_slider/green(null,i,"[xval+i],[yval-2]", src)
				pieces += new /obj/FTCS_Object/color_slider/blue(null,i,"[xval+i],[yval-3]", src)

		Done()
			waiting = FALSE

		Set_Background(xval,yval,client/C)
			background += new /obj/FTCS_Object/background(null,"[xval+4],[yval-1]",C)

		Show_Buttons(xval,yval,client/C)
			ok_buttons += new /obj/FTCS_Object/ok_buttons(null,"[xval+4],[yval-3]","O",C, src)
			ok_buttons += new /obj/FTCS_Object/ok_buttons(null,"[xval+5],[yval-3]","K",C, src)
			background += new /obj/FTCS_Object/cancel_button(null, "[xval+5],[yval-2]", C, src)
			background += new /obj/FTCS_Object/help_button(null, "[xval+4],[yval-2]", C, src)

		Show_Text(xval,yval,client/C)
			var/i
			for(i=1, i<=6, i++)
				var/obj/O = new(null)
				O.text = "<font bgcolor=[FTCS_Background] color=#000055>[copytext("Select",i,i+1)]"
				O.screen_loc = "[xval-1+i],[yval+1]"
				O.layer = FTCS_Layer
				O.name = "Select Color"
				C.screen += O
				background += O
			for(i=1, i<=6, i++)
				var/obj/O = new(null)
				O.text = "<font bgcolor=[FTCS_Background] color=#000055>[copytext("Color ",i,i+1)]"
				O.screen_loc = "[xval-1+i],[yval]"
				O.layer = FTCS_Layer
				O.name = "Select Color"
				C.screen += O
				background += O



		Update_Color(base_color, value)
			switch(base_color)
				if("RED")
					R = value
				if("GREEN")
					G = value
				if("BLUE")
					B = value
			current_color = rgb(R,G,B)
			Current_Color.Update_Color(current_color)

		Get_Color(client/C)
			for(var/V in pieces)
				C.screen += V
			while(waiting)
				sleep(10)
			return current_color

		Get_X(client/C)
			if(isnum(C.view))  //If view is already a number, set xval and yval
				if(C.view >=4)
					return C.view-3
				else
					return 1
			else													//If not, it is a text var.  Parse the xval and yval values
				var/divider = findtext(lowertext(C.view), "x")
				var/xval = text2num(copytext(C.view, 1, divider))
				if(xval >= 6)
					return round(xval/2 - 3)
				else
					return 0
		Get_Y(client/C)
			if(isnum(C.view))  //If view is already a number, set xval and yval
				if(C.view >=2)
					return C.view+3
				else
					return 5
			else													//If not, it is a text var.  Parse the xval and yval values
				var/divider = findtext(lowertext(C.view), "x")
				var/yval = text2num(copytext(C.view, divider+1))
				if(yval >= 6)
					return round(yval/2 + 3)
				else
					return 5




//				yval = text2num(copytext(C.view, divider+1))


obj/FTCS_Object
	color_slider
		layer = FTCS_Layer
		var
			base_color
			base_value
			Yval
			Xval
			f_text_color_selector/Owner
		New(loc,position, s_loc, f_text_color_selector/F)
			..()
			Owner = F
			base_value = 2*position*32
			screen_loc = s_loc


		MouseUp(location, icon_x, icon_y)
			Owner.Update_Color(base_color, base_value+2*icon_x)


		red
			base_color = "RED"
			name = "Red"
			New()
				..()
				text = "<font bgcolor=[rgb(base_value+32,0,0)]> "

		green
			base_color = "GREEN"
			name = "Green"
			New()
				..()
				text = "<font bgcolor=[rgb(0,base_value+32,0)]> "

		blue
			base_color = "BLUE"
			name = "Blue"
			New()
				..()
				text = "<font bgcolor=[rgb(0,0,base_value+32)]> "

obj/FTCS_Object
	current_color
		name = "Current Color"
		layer = FTCS_Layer
		text = "<font bgcolor=#000001> "
		New(loc,s_loc,client/C)
			..()
			screen_loc = s_loc
			C.screen += src
		proc
			Update_Color(value)
				text = "<font bgcolor=[value]> "
	ok_buttons
		layer = FTCS_Layer
		name = "OK"
		var
			f_text_color_selector/Owner
		New(loc,s_loc,letter, client/C, f_text_color_selector/F)
			..()
			Owner = F
			screen_loc = s_loc
			text = "<font bgcolor=[FTCS_Button] color=#000055>[letter]"
			C.screen += src
		Click()
			..()
			Owner.Done()

	cancel_button
		layer = FTCS_Layer
		name = "Cancel"
		var
			f_text_color_selector/Owner
		New(loc,s_loc, client/C, f_text_color_selector/F)
			..()
			Owner = F
			screen_loc = s_loc
			text = "<font bgcolor=[FTCS_Cancel_Background] color=[FTCS_Cancel]>X"
			C.screen += src
		Click()
			..()
			Owner.Cancel()

	background
		name = ""
		layer = FTCS_Layer-1
		New(loc,s_loc,client/C)
			..()
			text = "<font bgcolor=[FTCS_Background]> "
			screen_loc = s_loc
			C.screen += src

	help_button
		name = "Help"
		layer = FTCS_Layer
		var
			f_text_color_selector/Owner
		New(loc,s_loc, client/C, f_text_color_selector/F)
			..()
			Owner = F
			text = "<font bgcolor=[FTCS_Help_Background] color=[FTCS_Help_Color]>?"
			screen_loc = s_loc
			C.screen += src
		Click()
			..()
			usr << {"
<b>Basic Help</b>
To select a color, simply click on the red, green and blue selection
bars until you get the color you want.  Selection is pixel based, so
clicking on different parts of a selection box will give you different
values.
			"}




