/*
   Just a simple demo on how to use the library.  The only proc you need to call
   is F_TCS.Get_Color(mob/M, default_color)

   You may actually pass either a mob with a client, or a client directly as the first
   argument.  The second argument is optional.  If you pass an html color code, the
   current_color box of the input will be set to that color.

   You will need to set up a test to determine if the player actually selected a
   color.  If they cancel, the proc returns null.

   The input box should be approximately centered in the clients view.  This should
   work for both numeric views, and odd sized views. (EX: view = "15x6")  On very
   small views, the input box will force the clients view to expand to fit.

*/

#include "test.dmp"

mob
	text = "@"
	var
		text_color = "#000000"
		my_color = "#999999"
	verb
		Set_Text_Color()
			var/new_color = F_TCS.Get_Color(src, text_color)  //  Test var
			if(new_color)                                     //  If the var was set
				text_color = new_color                          //  Set my color to the var.


client
	view = "21x17"																				//  Input centered for odd views.

	verb
		Set_My_Color()
			var/new_color = F_TCS.Get_Color(src, mob.my_color)
			if(new_color)
				mob.my_color = new_color
				mob.text = "<font color=[mob.my_color]>@"



//  Demo setup information not related to the library.

mob
	verb
		Say(msg as text)
			if(msg)
				world << "<b><font color=[my_color]>[src]:</font></b> <font color=[text_color]>[html_encode(msg)]</font>"

turf
	grass
		text = "<font bgcolor=#00aa00> "
	forest
		text = "<font bgcolor=#007700> "
	water
		text = "<font bgcolor=#0055aa> "
		density = 1

client
	New()
		..()
		world << "[src] has entered the world."

	Del()
		world << "[src] has left the world."
		del mob
		..()
